import React from 'react';
import MoleculeDropdownList from '@s-ui/react-molecule-dropdown-list';
import MoleculeInputTags from '@s-ui/react-molecule-input-tags';
import withSelectUI from '../hoc/withSelectUI';
var MoleculeInputSelect = withSelectUI(MoleculeInputTags);

var MoleculeSelectFieldMultiSelection = function MoleculeSelectFieldMultiSelection(props) {
  /* eslint-disable react/prop-types */
  var children = props.children,
      isOpen = props.isOpen,
      onToggle = props.onToggle,
      onChange = props.onChange,
      iconArrowDown = props.iconArrowDown,
      iconCloseTag = props.iconCloseTag,
      refMoleculeSelect = props.refMoleculeSelect,
      values = props.value,
      placeholder = props.placeholder,
      keysSelection = props.keysSelection,
      id = props.id,
      size = props.size,
      required = props.required,
      _props$optionsData = props.optionsData,
      optionsData = _props$optionsData === void 0 ? {} : _props$optionsData,
      selectSize = props.selectSize,
      tabIndex = props.tabIndex;

  var handleMultiSelection = function handleMultiSelection(ev, _ref) {
    var valueOptionSelected = _ref.value;
    var newValues = values.includes(valueOptionSelected) ? values.filter(function (value) {
      return value !== valueOptionSelected;
    }) : [].concat(values, [valueOptionSelected]);
    var key = ev.key;
    var isKeySelection = keysSelection.includes(key);
    onChange(ev, {
      value: newValues
    });
    if (ev.key !== undefined && !isKeySelection) onToggle(ev, {
      isOpen: false
    });
  };

  var handleChangeTags = function handleChangeTags(ev, _ref2) {
    var value = _ref2.tags;
    onChange(ev, {
      value: value
    });
    refMoleculeSelect.current.focus();
  };

  var tags = values.map(function (value) {
    return optionsData[value];
  });
  return React.createElement(React.Fragment, null, React.createElement(MoleculeInputSelect, {
    id: id,
    tags: tags,
    onClick: onToggle,
    tagsCloseIcon: iconCloseTag,
    iconArrowDown: iconArrowDown,
    onChangeTags: handleChangeTags,
    isOpen: isOpen,
    placeholder: !values.length ? placeholder : '',
    optionsData: optionsData,
    autoComplete: "off",
    readOnly: true,
    noBorder: true,
    required: required,
    size: selectSize,
    tabIndex: tabIndex
  }), React.createElement(MoleculeDropdownList, {
    checkbox: true,
    size: size,
    visible: isOpen,
    onSelect: handleMultiSelection,
    value: values
  }, children));
};

MoleculeSelectFieldMultiSelection.displayName = 'MoleculeSelectFieldMultiSelection';
MoleculeSelectFieldMultiSelection.defaultProps = {
  value: []
};
export default MoleculeSelectFieldMultiSelection;